PHPExcel_Calculation

# Class: PHPExcel_Calculation_DateTime

Source Location: /PHPExcel/Calculation/DateTime.php

### Class Overview

PHPExcel_Calculation_DateTime

#### Author(s):

#### Copyright:

- Copyright (c) 2006 - 2012 PHPExcel (http://www.codeplex.com/PHPExcel)

### Methods

- DATE
- DATEDIF
- DATENOW
- DATETIMENOW
- DATEVALUE
- DAYOFMONTH
- DAYOFWEEK
- DAYS360
- EDATE
- EOMONTH
- HOUROFDAY
- MINUTEOFHOUR
- MONTHOFYEAR
- NETWORKDAYS
- SECONDOFMINUTE
- TIME
- TIMEVALUE
- WEEKOFYEAR
- WORKDAY
- YEAR
- YEARFRAC
- _getDateValue
- _isLeapYear

### Class Details

[line 46]
PHPExcel_Calculation_DateTime

#### Tags:

copyright: | Copyright (c) 2006 - 2012 PHPExcel (http://www.codeplex.com/PHPExcel)

[ Top ]

### Class Methods

### static method DATE [line 276]

`static mixed DATE( [integer $year = 0], [integer $month = 1], [integer $day = 1])`

DATE

The DATE function returns a value that represents a particular date.

NOTE: When used in a Cell Formula, MS Excel changes the cell format so that it matches the date format of your regional settings. PHPExcel does not change cell formatting in this way.

Excel Function: DATE(year,month,day)

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

#### Parameters:

integer

$year

The value of the year argument can include one to four digits. Excel interprets the year argument according to the configured date system: 1900 or 1904. If year is between 0 (zero) and 1899 (inclusive), Excel adds that value to 1900 to calculate the year. For example, DATE(108,1,2) returns January 2, 2008 (1900+108). If year is between 1900 and 9999 (inclusive), Excel uses that value as the year. For example, DATE(2008,1,2) returns January 2, 2008. If year is less than 0 or is 10000 or greater, Excel returns the #NUM! error value.

integer

$month

A positive or negative integer representing the month of the year from 1 to 12 (January to December). If month is greater than 12, month adds that number of months to the first month in the year specified. For example, DATE(2008,14,2) returns the serial number representing February 2, 2009. If month is less than 1, month subtracts the magnitude of that number of months, plus 1, from the first month in the year specified. For example, DATE(2008,-3,2) returns the serial number representing September 2, 2007.

integer

$day

A positive or negative integer representing the day of the month from 1 to 31. If day is greater than the number of days in the month specified, day adds that number of days to the first day in the month. For example, DATE(2008,1,35) returns the serial number representing February 4, 2008. If day is less than 1, day subtracts the magnitude that number of days, plus one, from the first day of the month specified. For example, DATE(2008,1,-15) returns the serial number representing December 16, 2007.

[ Top ]

### static method DATEDIF [line 594]

`static integer DATEDIF( [mixed $startDate = 0], [mixed $endDate = 0], [string $unit = 'D'])`

DATEDIF

#### Tags:

return: | Interval between the dates
access: | public

#### Parameters:

mixed | $startDate | Excel date serial value, PHP date/time stamp, PHP DateTime object or a standard date string
mixed | $endDate | Excel date serial value, PHP date/time stamp, PHP DateTime object or a standard date string
string | $unit |

[ Top ]

### static method DATENOW [line 208]

`static mixed DATENOW( )`

DATENOW

Returns the current date. The NOW function is useful when you need to display the current date and time on a worksheet or calculate a value based on the current date and time, and have that value updated each time you open the worksheet.

NOTE: When used in a Cell Formula, MS Excel changes the cell format so that it matches the date and time format of your regional settings. PHPExcel does not change cell formatting in this way.

Excel Function: TODAY()

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

[ Top ]

### static method DATETIMENOW [line 168]

`static mixed DATETIMENOW( )`

DATETIMENOW

Returns the current date and time. The NOW function is useful when you need to display the current date and time on a worksheet or calculate a value based on the current date and time, and have that value updated each time you open the worksheet.

NOTE: When used in a Cell Formula, MS Excel changes the cell format so that it matches the date and time format of your regional settings. PHPExcel does not change cell formatting in this way.

Excel Function: NOW()

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

[ Top ]

### static method DATEVALUE [line 457]

`static mixed DATEVALUE( [string $dateValue = 1])`

DATEVALUE

Returns a value that represents a particular date. Use DATEVALUE to convert a date represented by a text string to an Excel or PHP date/time stamp value.

NOTE: When used in a Cell Formula, MS Excel changes the cell format so that it matches the date format of your regional settings. PHPExcel does not change cell formatting in this way.

Excel Function: DATEVALUE(dateValue)

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

#### Parameters:

string

$dateValue

Text that represents a date in a Microsoft Excel date format. For example, "1/30/2008" or "30-Jan-2008" are text strings within quotation marks that represent dates. Using the default date system in Excel for Windows, date_text must represent a date from January 1, 1900, to December 31, 9999. Using the default date system in Excel for the Macintosh, date_text must represent a date from January 1, 1904, to December 31, 9999. DATEVALUE returns the #VALUE! error value if date_text is out of this range.

[ Top ]

### static method DAYOFMONTH [line 1043]

`static int DAYOFMONTH( [mixed $dateValue = 1])`

DAYOFMONTH

Returns the day of the month, for a specified date. The day is given as an integer ranging from 1 to 31.

Excel Function: DAY(dateValue)

#### Tags:

return: | Day of the month
access: | public

#### Parameters:

mixed | $dateValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string

[ Top ]

### static method DAYOFWEEK [line 1078]

`static int DAYOFWEEK( [mixed $dateValue = 1], [int $style = 1])`

DAYOFWEEK

Returns the day of the week for a specified date. The day is given as an integer ranging from 0 to 7 (dependent on the requested style).

Excel Function: WEEKDAY(dateValue[,style])

#### Tags:

return: | Day of the week value
access: | public

#### Parameters:

mixed | $dateValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string

int

$style

A number that determines the type of return value

1. or omitted Numbers 1 (Sunday) through 7 (Saturday).
2. Numbers 1 (Monday) through 7 (Sunday).
3. Numbers 0 (Monday) through 6 (Sunday).

[ Top ]

### static method DAYS360 [line 712]

`static integer DAYS360( [mixed $startDate = 0], [mixed $endDate = 0], [boolean $method = false])`

DAYS360

Returns the number of days between two dates based on a 360-day year (twelve 30-day months), which is used in some accounting calculations. Use this function to help compute payments if your accounting system is based on twelve 30-day months.

Excel Function: DAYS360(startDate,endDate[,method])

#### Tags:

return: | Number of days between start date and end date
access: | public

#### Parameters:

mixed | $startDate | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string
mixed | $endDate | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string

boolean

$method

US or European Method FALSE or omitted: U.S. (NASD) method. If the starting date is the last day of a month, it becomes equal to the 30th of the same month. If the ending date is the last day of a month and the starting date is earlier than the 30th of a month, the ending date becomes equal to the 1st of the next month; otherwise the ending date becomes equal to the 30th of the same month. TRUE: European method. Starting dates and ending dates that occur on the 31st of a month become equal to the 30th of the same month.

[ Top ]

### static method EDATE [line 1372]

`static mixed EDATE( [mixed $dateValue = 1], [int $adjustmentMonths = 0])`

EDATE

Returns the serial number that represents the date that is the indicated number of months before or after a specified date (the start_date). Use EDATE to calculate maturity dates or due dates that fall on the same day of the month as the date of issue.

Excel Function: EDATE(dateValue,adjustmentMonths)

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

#### Parameters:

mixed | $dateValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string
int | $adjustmentMonths | The number of months before or after start_date. A positive value for months yields a future date; a negative value yields a past date.

[ Top ]

### static method EOMONTH [line 1417]

`static mixed EOMONTH( [mixed $dateValue = 1], [int $adjustmentMonths = 0])`

EOMONTH

Returns the date value for the last day of the month that is the indicated number of months before or after start_date. Use EOMONTH to calculate maturity dates or due dates that fall on the last day of the month.

Excel Function: EOMONTH(dateValue,adjustmentMonths)

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

#### Parameters:

mixed | $dateValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string
int | $adjustmentMonths | The number of months before or after start_date. A positive value for months yields a future date; a negative value yields a past date.

[ Top ]

### static method HOUROFDAY [line 1246]

`static int HOUROFDAY( [mixed $timeValue = 0])`

HOUROFDAY

Returns the hour of a time value. The hour is given as an integer, ranging from 0 (12:00 A.M.) to 23 (11:00 P.M.).

Excel Function: HOUR(timeValue)

#### Tags:

return: | Hour
access: | public

#### Parameters:

mixed | $timeValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard time string

[ Top ]

### static method MINUTEOFHOUR [line 1286]

`static int MINUTEOFHOUR( [mixed $timeValue = 0])`

MINUTEOFHOUR

Returns the minutes of a time value. The minute is given as an integer, ranging from 0 to 59.

Excel Function: MINUTE(timeValue)

#### Tags:

return: | Minute
access: | public

#### Parameters:

mixed | $timeValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard time string

[ Top ]

### static method MONTHOFYEAR [line 1188]

`static int MONTHOFYEAR( [mixed $dateValue = 1])`

MONTHOFYEAR

Returns the month of a date represented by a serial number. The month is given as an integer, ranging from 1 (January) to 12 (December).

Excel Function: MONTH(dateValue)

#### Tags:

return: | Month of the year
access: | public

#### Parameters:

mixed | $dateValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string

[ Top ]

### static method NETWORKDAYS [line 858]

`static integer NETWORKDAYS( mixed $startDate, mixed $endDate, mixed $holidays,...)`

NETWORKDAYS

Returns the number of whole working days between start_date and end_date. Working days exclude weekends and any dates identified in holidays. Use NETWORKDAYS to calculate employee benefits that accrue based on the number of days worked during a specific term.

Excel Function: NETWORKDAYS(startDate,endDate[,holidays[,holiday[,...]]])

#### Tags:

return: | Interval between the dates
access: | public

#### Parameters:

mixed | $startDate | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string
mixed | $endDate | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string
mixed | $holidays,... | Optional series of Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date strings that will be excluded from the working calendar, such as state and federal holidays and floating holidays.

[ Top ]

### static method SECONDOFMINUTE [line 1326]

`static int SECONDOFMINUTE( [mixed $timeValue = 0])`

SECONDOFMINUTE

Returns the seconds of a time value. The second is given as an integer in the range 0 (zero) to 59.

Excel Function: SECOND(timeValue)

#### Tags:

return: | Second
access: | public

#### Parameters:

mixed | $timeValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard time string

[ Top ]

### static method TIME [line 362]

`static mixed TIME( [integer $hour = 0], [integer $minute = 0], [integer $second = 0])`

TIME

The TIME function returns a value that represents a particular time.

NOTE: When used in a Cell Formula, MS Excel changes the cell format so that it matches the time format of your regional settings. PHPExcel does not change cell formatting in this way.

Excel Function: TIME(hour,minute,second)

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

#### Parameters:

integer | $hour | A number from 0 (zero) to 32767 representing the hour. Any value greater than 23 will be divided by 24 and the remainder will be treated as the hour value. For example, TIME(27,0,0) = TIME(3,0,0) = .125 or 3:00 AM.
integer | $minute | A number from 0 to 32767 representing the minute. Any value greater than 59 will be converted to hours and minutes. For example, TIME(0,750,0) = TIME(12,30,0) = .520833 or 12:30 PM.
integer | $second | A number from 0 to 32767 representing the second. Any value greater than 59 will be converted to hours, minutes, and seconds. For example, TIME(0,0,2000) = TIME(0,33,22) = .023148 or 12:33:20 AM

[ Top ]

### static method TIMEVALUE [line 559]

`static mixed TIMEVALUE( string $timeValue)`

TIMEVALUE

Returns a value that represents a particular time. Use TIMEVALUE to convert a time represented by a text string to an Excel or PHP date/time stamp value.

NOTE: When used in a Cell Formula, MS Excel changes the cell format so that it matches the time format of your regional settings. PHPExcel does not change cell formatting in this way.

Excel Function: TIMEVALUE(timeValue)

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

#### Parameters:

string | $timeValue | A text string that represents a time in any one of the Microsoft Excel time formats; for example, "6:45 PM" and "18:45" text strings within quotation marks that represent time. Date information in time_text is ignored.

[ Top ]

### static method WEEKOFYEAR [line 1144]

`static int WEEKOFYEAR( [mixed $dateValue = 1], [boolean $method = 1])`

WEEKOFYEAR

Returns the week of the year for a specified date. The WEEKNUM function considers the week containing January 1 to be the first week of the year. However, there is a European standard that defines the first week as the one with the majority of days (four or more) falling in the new year. This means that for years in which there are three days or less in the first week of January, the WEEKNUM function returns week numbers that are incorrect according to the European standard.

Excel Function: WEEKNUM(dateValue[,style])

#### Tags:

return: | Week Number
access: | public

#### Parameters:

mixed | $dateValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string

boolean

$method

Week begins on Sunday or Monday

1. or omitted Week begins on Sunday.
2. Week begins on Monday.

[ Top ]

### static method WORKDAY [line 940]

`static mixed WORKDAY( mixed $startDate, integer $endDays, mixed $holidays,...)`

WORKDAY

Returns the date that is the indicated number of working days before or after a date (the starting date). Working days exclude weekends and any dates identified as holidays. Use WORKDAY to exclude weekends or holidays when you calculate invoice due dates, expected delivery times, or the number of days of work performed.

Excel Function: WORKDAY(startDate,endDays[,holidays[,holiday[,...]]])

#### Tags:

return: | Excel date/time serial value, PHP date/time serial value or PHP date/time object, depending on the value of the ReturnDateType flag
access: | public

#### Parameters:

mixed | $startDate | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string
integer | $endDays | The number of nonweekend and nonholiday days before or after startDate. A positive value for days yields a future date; a negative value yields a past date.
mixed | $holidays,... | Optional series of Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date strings that will be excluded from the working calendar, such as state and federal holidays and floating holidays.

[ Top ]

### static method YEAR [line 1217]

`static int YEAR( [mixed $dateValue = 1])`

YEAR

Returns the year corresponding to a date. The year is returned as an integer in the range 1900-9999.

Excel Function: YEAR(dateValue)

#### Tags:

return: | Year
access: | public

#### Parameters:

mixed | $dateValue | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string

[ Top ]

### static method YEARFRAC [line 763]

`static float YEARFRAC( [mixed $startDate = 0], [mixed $endDate = 0], [integer $method = 0])`

YEARFRAC

Calculates the fraction of the year represented by the number of whole days between two dates (the start_date and the end_date). Use the YEARFRAC worksheet function to identify the proportion of a whole year's benefits or obligations to assign to a specific term.

Excel Function: YEARFRAC(startDate,endDate[,method])

#### Tags:

return: | fraction of the year
access: | public

#### Parameters:

mixed | $startDate | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string
mixed | $endDate | Excel date serial value (float), PHP date timestamp (integer), PHP DateTime object, or a standard date string

integer

$method

Method used for the calculation

1. or omitted US (NASD) 30/360
2. Actual/actual
3. Actual/360
4. Actual/365
5. European 30/360

[ Top ]

### static method _getDateValue [line 89]

`static mixed _getDateValue( string $dateValue)`

_getDateValue

#### Tags:

return: | Excel date/time serial value, or string if error
access: | public

#### Parameters:

string | $dateValue |

[ Top ]

### static method _isLeapYear [line 54]

`static boolean _isLeapYear( integer $year)`

Identify if a year is a leap year or not

#### Tags:

return: | TRUE if the year is a leap year, otherwise FALSE
access: | public

#### Parameters:

integer | $year | The year to test

[ Top ]

Documentation generated on Fri, 12 Oct 2012 00:15:42 +0200 by phpDocumentor 1.4.4